DAEMON(3) | Library Functions Manual | DAEMON(3)

# NAME

`daemon` —
run in the background

# LIBRARY

Standard C Library (libc, -lc)

# SYNOPSIS

`#include <stdlib.h>`

int
`daemon`(int nochdir, int noclose);

# DESCRIPTION

The `daemon`() function is for programs wishing to detach themselves from the controlling terminal and run in the background as system daemons.

Unless the argument nochdir is non-zero, `daemon`() changes the current working directory to the root (/).

Unless the argument noclose is non-zero, `daemon`() will redirect standard input, standard output and standard error to /dev/null.

# RETURN VALUES

On return 0 indicates success with -1 indicating error.

# ERRORS

The function `daemon`() may fail and set errno for any of the errors specified for the library functions fork(2) and setsid(2).

# SEE ALSO

fork(2), setsid(2)

# HISTORY

The `daemon`() function first appeared in 4.4BSD.

# CAVEATS

Unless the noclose argument is non-zero, `daemon`() will close the first three file descriptors and redirect them to /dev/null. Normally, these correspond to standard input, standard output and standard error. However, if any of those file descriptors refer to something else they will still be closed, resulting in incorrect behavior of the calling program. This can happen if any of standard input, standard output or standard error have been closed before the program was run. Programs using `daemon`() should therefore make sure to either call `daemon`() before opening any files or sockets or, alternately, verifying that any file descriptors obtained have a value greater than 2.

# BUGS

`daemon`() uses `fork`() as part of its tty detachment mechanism. Consequently the process id changes when `daemon`() is invoked. Processes employing `daemon`() can not be reliably waited upon until `daemon`() has been invoked.

September 3, 1999 | NetBSD 9.0